=== src/fuse/supported/CMakeLists.txt ===
# Add sources required by all concrete backends.
add_subdirectory(common)

# Add platform-specific sources.
add_subdirectory(platform)
