=== include/mega/fuse/common/CMakeLists.txt ===
target_sources(SDKlib PRIVATE
                      any_lock.h
                      any_lock_forward.h
                      any_lock_set.h
                      any_lock_set_forward.h
                      client.h
                      file_explorer_view.h
                      file_move_flag.h
                      file_move_flag_forward.h
                      file_open_flag.h
                      file_open_flag_forward.h
                      inode_cache_flags.h
                      inode_cache_flags_forward.h
                      inode_id.h
                      inode_id_forward.h
                      inode_info.h
                      inode_info_forward.h
                      logger.h
                      logging.h
                      mount_event.h
                      mount_event_forward.h
                      mount_event_type.h
                      mount_event_type_forward.h
                      mount_flags.h
                      mount_flags_forward.h
                      mount_info.h
                      mount_info_forward.h
                      mount_inode_id.h
                      mount_inode_id_forward.h
                      mount_result.h
                      mount_result_forward.h
                      service.h
                      service_callbacks.h
                      service_context.h
                      service_context_forward.h
                      service_flags.h
                      service_flags_forward.h
                      service_forward.h
)
